// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from udp_msgs:msg/UdpPacket.idl
// generated code does not contain a copyright notice

#ifndef UDP_MSGS__MSG__DETAIL__UDP_PACKET__TRAITS_HPP_
#define UDP_MSGS__MSG__DETAIL__UDP_PACKET__TRAITS_HPP_

#include "udp_msgs/msg/detail/udp_packet__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const udp_msgs::msg::UdpPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "address: ";
    value_to_yaml(msg.address, out);
    out << "\n";
  }

  // member: src_port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "src_port: ";
    value_to_yaml(msg.src_port, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const udp_msgs::msg::UdpPacket & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<udp_msgs::msg::UdpPacket>()
{
  return "udp_msgs::msg::UdpPacket";
}

template<>
inline const char * name<udp_msgs::msg::UdpPacket>()
{
  return "udp_msgs/msg/UdpPacket";
}

template<>
struct has_fixed_size<udp_msgs::msg::UdpPacket>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<udp_msgs::msg::UdpPacket>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<udp_msgs::msg::UdpPacket>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // UDP_MSGS__MSG__DETAIL__UDP_PACKET__TRAITS_HPP_
