// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from udp_msgs:srv/UdpSend.idl
// generated code does not contain a copyright notice

#ifndef UDP_MSGS__SRV__DETAIL__UDP_SEND__TRAITS_HPP_
#define UDP_MSGS__SRV__DETAIL__UDP_SEND__TRAITS_HPP_

#include "udp_msgs/srv/detail/udp_send__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const udp_msgs::srv::UdpSend_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: local_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "local_address: ";
    value_to_yaml(msg.local_address, out);
    out << "\n";
  }

  // member: local_port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "local_port: ";
    value_to_yaml(msg.local_port, out);
    out << "\n";
  }

  // member: remote_address
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remote_address: ";
    value_to_yaml(msg.remote_address, out);
    out << "\n";
  }

  // member: remote_port
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "remote_port: ";
    value_to_yaml(msg.remote_port, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const udp_msgs::srv::UdpSend_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<udp_msgs::srv::UdpSend_Request>()
{
  return "udp_msgs::srv::UdpSend_Request";
}

template<>
inline const char * name<udp_msgs::srv::UdpSend_Request>()
{
  return "udp_msgs/srv/UdpSend_Request";
}

template<>
struct has_fixed_size<udp_msgs::srv::UdpSend_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<udp_msgs::srv::UdpSend_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<udp_msgs::srv::UdpSend_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const udp_msgs::srv::UdpSend_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: sent
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sent: ";
    value_to_yaml(msg.sent, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const udp_msgs::srv::UdpSend_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<udp_msgs::srv::UdpSend_Response>()
{
  return "udp_msgs::srv::UdpSend_Response";
}

template<>
inline const char * name<udp_msgs::srv::UdpSend_Response>()
{
  return "udp_msgs/srv/UdpSend_Response";
}

template<>
struct has_fixed_size<udp_msgs::srv::UdpSend_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<udp_msgs::srv::UdpSend_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<udp_msgs::srv::UdpSend_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<udp_msgs::srv::UdpSend>()
{
  return "udp_msgs::srv::UdpSend";
}

template<>
inline const char * name<udp_msgs::srv::UdpSend>()
{
  return "udp_msgs/srv/UdpSend";
}

template<>
struct has_fixed_size<udp_msgs::srv::UdpSend>
  : std::integral_constant<
    bool,
    has_fixed_size<udp_msgs::srv::UdpSend_Request>::value &&
    has_fixed_size<udp_msgs::srv::UdpSend_Response>::value
  >
{
};

template<>
struct has_bounded_size<udp_msgs::srv::UdpSend>
  : std::integral_constant<
    bool,
    has_bounded_size<udp_msgs::srv::UdpSend_Request>::value &&
    has_bounded_size<udp_msgs::srv::UdpSend_Response>::value
  >
{
};

template<>
struct is_service<udp_msgs::srv::UdpSend>
  : std::true_type
{
};

template<>
struct is_service_request<udp_msgs::srv::UdpSend_Request>
  : std::true_type
{
};

template<>
struct is_service_response<udp_msgs::srv::UdpSend_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // UDP_MSGS__SRV__DETAIL__UDP_SEND__TRAITS_HPP_
